Function WmiQuery(strQueryString, lngMaxRows, blnStop100)
	Dim lngCount
	Dim strResult
	Dim wmiLocator, wmiServices
	Dim wmiObjectSet, wmiObject, wmiProperty
	Dim wmiDateTime
	
	Set wmiLocator = CreateObject("WbemScripting.SWbemLocator")
	Set wmiServices = wmiLocator.ConnectServer()
	Set wmiObjectSet = wmiServices.ExecQuery(strQueryString)
	Set wmiDateTime = CreateObject("WbemScripting.SWbemDateTime")
	
	lngCount = 0
	For Each wmiObject In wmiObjectSet
		If lngCount = 0 Then
			strResult = "<THEAD class=""resultSet""><TR><TH>&nbsp;</TH>"
			For Each wmiProperty In wmiObject.Properties_
				With wmiProperty
					strResult = strResult & "<TH nowrap>" & GetHeaderText(.Name, .CIMType, .IsArray) & "</TH>"
				End With
			Next
			strResult = strResult & "</TR></THEAD><TBODY class=""resultSet"">"
		End If
		strResult = strResult & "<TR><TH>" & CStr(lngCount + 1) & "</TH>"
		For Each wmiProperty In wmiObject.Properties_
			With wmiProperty
				If .IsArray Then
					If IsNull(.Value) Then
						strResult = strResult & "<TD class=""resultInfo"">(null)</TD>"
					Else
						strResult = strResult & "<TD>"
						For lngIndex = LBound(.Value) To UBound(.Value)
							strResult = strResult & GetValueText(wmiDateTime, CStr(.Value(lngIndex)), .CIMType, "[" & CStr(lngIndex) & "] ") & "<BR>"
						Next
						strResult = strResult & "</TD>"
					End If
				Else
					If IsNull(.Value) Then
						strResult = strResult & "<TD class=""resultInfo"">(null)</TD>"
					Else
						strResult = strResult & "<TD class=""resultText"">" & GetValueText(wmiDateTime, CStr(.Value), .CIMType, "") & "</TD>"
					End If
				End If
			End With
		Next
		strResult = strResult & "</TR>"
		lngCount = lngCount + 1
		Call SetStatusText("F " & CStr(lngCount))
		If lngCount = lngMaxRows And lngMaxRows > 0 Then
			Call SetStatusText("F " & CStr(lngCount) & " (" & CStr(lngMaxRows) & "Œ~܂)")
			Exit For
		End If
		If lngCount Mod 100 = 0 And blnStop100 Then
			If vbsMsgBoxQuestion("R[h " & CStr(lngCount) & " ɂȂ܂B擾𒆎~܂H" & vbNewLine & " " & CStr(lngCount + 100) & " Œf܂B", CStr(lngCount) & " 擾܂", True) Then
				Exit For
			End If
		End If
	Next
	If lngCount = 0 Then
		Call SetStatusText("F 0")
	End If
	strResult = strResult & "</TBODY>"
	
	Set wmiProperty = Nothing
	Set wmiObject = Nothing
	Set wmiDateTime = Nothing
	Set wmiObjectSet = Nothing
	Set wmiServices = Nothing
	Set wmiLocator = Nothing
	
	WmiQuery = "<TABLE class=""resultSet"">" & strResult & "</TABLE>"
End Function

Function GetHeaderText(strName, lngType, blnIsArray)
	Dim strTypeName
	
	Select Case lngType
	Case 11 'wbemCimtypeBoolean
		strTypeName = "Boolean"
	Case 103 'wbemCimtypeChar16
		strTypeName = "Char16"
	Case 101 'wbemCimtypeDatetime
		strTypeName = "Datetime"
	Case 13 'wbemCimtypeObject
		strTypeName = "Object"
	Case 4 'wbemCimtypeReal32
		strTypeName = "Real32"
	Case 5 'wbemCimtypeReal64
		strTypeName = "Real64"
	Case 102 'wbemCimtypeReference
		strTypeName = "Reference"
	Case 2 'wbemCimtypeSint16
		strTypeName = "Sint16"
	Case 3 'wbemCimtypeSint32
		strTypeName = "Sint32"
	Case 20 'wbemCimtypeSint64
		strTypeName = "Sint64"
	Case 16 'wbemCimtypeSint8
		strTypeName = "Sint8"
	Case 8 'wbemCimtypeString
		strTypeName = "String"
	Case 18 'wbemCimtypeUint16
		strTypeName = "Uint16"
	Case 19 'wbemCimtypeUint32
		strTypeName = "Uint32"
	Case 21 'wbemCimtypeUint64
		strTypeName = "Uint64"
	Case 17 'wbemCimtypeUint8
		strTypeName = "Uint8"
	Case Else
		strTypeName = "UnknownType(" & CStr(lngType) & ")"
	End Select
	If blnIsArray Then
		GetHeaderText = strName & "<BR><SPAN class=""resultTextBlue"">" & strTypeName & "</SPAN><SPAN class=""resultTextMagenta"">[z]</SPAN>"
	Else
		GetHeaderText = strName & "<BR><SPAN class=""resultTextBlue"">" & strTypeName & "</SPAN>"
	End If
End Function

Function GetValueText(wmiDateTime, varValue, lngType, strArray)
	If lngType = 11 Then 'wbemCimtypeBoolean
		If varValue Then
			GetValueText = "<SPAN class=""resultTextBoolean"">" & strArray & "(true)</SPAN>"
		Else
			GetValueText = "<SPAN class=""resultTextBoolean"">" & strArray & "(false)</SPAN>"
		End If
	ElseIf lngType = 103 Or lngType = 8 Then 'wbemCimtypeChar16, wbemCimtypeString
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 101 Then 'wbemCimtypeDatetime
		With wmiDateTime
			.Value = varValue
			GetValueText = strArray & .GetVarDate(False)
		End With
	ElseIf lngType = 2 Then 'wbemCimtypeSint16
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 3 Then 'wbemCimtypeSint32
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 20 Then 'wbemCimtypeSint64
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 16 Then 'wbemCimtypeSint8
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 18 Then 'wbemCimtypeUint16
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 19 Then 'wbemCimtypeUint32
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 21 Then 'wbemCimtypeUint64
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 17 Then 'wbemCimtypeUint8
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 13 Then 'wbemCimtypeObject
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 4 Then 'wbemCimtypeReal32
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 5 Then 'wbemCimtypeReal64
		GetValueText = strArray & CStr(varValue)
	ElseIf lngType = 102 Then 'wbemCimtypeReference
		GetValueText = strArray & CStr(varValue)
	Else 
		GetValueText = strArray & CStr(varValue)
	End If
End Function
